require "maps"
require "BObjects"

screenWidth = 640
screenHeight = 480
paddleY = 0
paddleX = 0
text = "<ESC> Quit,  <Q> Release Mouse, <Space> Launch Ball <S> Toggle Sound"
score = 0;

ballHit = false
wallHit = false
brickHit = false
ceilingHit = false
ballAlive = false
ballReset = true
soundEnabled = true
bitMouseDown = false
bonusDropping = false

currentLevel = 1
maxLevel = 7

explosions = {}
explosionCount = 0;

ammo = 0
bonusNum = 0
ballNum = 0
bulletNum = 0
bombNum = 0

intLives = 5
intBalls = 0
impactX = 0
impactY = 0
--rot = 0;
gameMode = "GAME_PLAY"  --"MENU_START"  "MENU_RESTART"  "MENU_END"

sfx_boom = love.audio.newSource("sfx-01b.mp3", "static")
sfx_boom2 = love.audio.newSource("sfx-01b.mp3", "static")
sfx_boom3 = love.audio.newSource("sfx-01b.mp3", "static")
sfx_serve = love.audio.newSource("sfx-02.mp3", "static")
sfx_reflect = love.audio.newSource("sfx-05.mp3", "static")
sfx_death = love.audio.newSource("sfx-01.mp3", "static")
sfx_bonus = love.audio.newSource("sfx-06.mp3", "static")

arrSoundBooms = {} 
arrSoundBooms[0] = sfx_boom 
arrSoundBooms[1] = sfx_boom2 
arrSoundBooms[2] = sfx_boom3
intBoomIdx = 0

function love.load()
  
   world = love.physics.newWorld(-640, -480, 640, 480)
   world:setGravity(0,100)
   world:setMeter(72)
   world:setCallbacks(add, persist, rem, result)
   
   setupObjects()

   love.graphics.setMode(screenWidth,screenHeight, false, true, 0)
   love.graphics.setCaption("BreakOut Love")
   createBall("Ball"..ballNum, 320, 465, false)
   drawMap()
   
end

function createBrick(name, bx,by,hp)
   objects.bricks[name] = {}
   objects.bricks[name].body = love.physics.newBody(world, bx, by, 0, 0) 
   objects.bricks[name].shape = love.physics.newRectangleShape(objects.bricks[name].body, 0, 0, 32, 16, 0) 
   objects.bricks[name].body:putToSleep()
   objects.bricks[name].markedForDeath = false;
   objects.bricks[name].shape:setData(name)
   objects.bricks[name].shape:setCategory(3)
   objects.bricks[name].intHP = hp
   objects.bricks[name].intIdleFrames = 0;
   setBrickAvatar(name) 
end
  
function createBallSplosion()
      for i = 1, 10 do
	 createBall("Ball"..ballNum, 320, 32)
          objects.balls["Ball"..ballNum - 1].body:applyImpulse( math.random(-480,480), -math.random(-640, 640), 0, 0 );
      end
   end

function setBrickAvatar(name)
      if(objects.bricks[name].intHP == 1) then
	 objects.bricks[name].avatar = brick;
      elseif (objects.bricks[name].intHP == 2) then
	 objects.bricks[name].avatar = brick2;
      elseif (objects.bricks[name].intHP == 3) then
	 objects.bricks[name].avatar = brick3;
      elseif (objects.bricks[name].intHP == 4) then
	 objects.bricks[name].avatar = brick4;
      elseif (objects.bricks[name].intHP==5) then
	 objects.bricks[name].avatar = brick5;
      elseif (objects.bricks[name].intHP == 6) then
	 objects.bricks[name].avatar = brick6;
      end
end

function healBrickHP(name, dmg)
      objects.bricks[name].intHP =  objects.bricks[name].intHP+dmg
      setBrickAvatar(name)
end

function createBall(name, bx, by, boost)
   objects.balls[name] = {}
   objects.balls[name].body = love.physics.newBody(world, bx, by, 100, 0) 
   objects.balls[name].shape = love.physics.newCircleShape(objects.balls[name].body, 0, 0, 8)
   objects.balls[name].shape:setData(name)
   objects.balls[name].shape:setCategory(5) 
   objects.balls[name].shape:setMask(5, 6)
   objects.balls[name].brickHit = false
   objects.balls[name].wallHit = false
   objects.balls[name].ceilingHit = false
   objects.balls[name].ballHit = false 
   objects.balls[name].isDead = false
   objects.balls[name].markedForDeath = false
   objects.balls[name].isBomb = false
   objects.balls[name].impactX = 0
   objects.balls[name].impactY = 0
   ballNum = ballNum + 1;
   if(boost == true) then
      objects.balls[name].body:setLinearVelocity(0,-480)
   end

end
function createBomb(name, bx, by)
   objects.bombs[name] = {}
   objects.bombs[name].body = love.physics.newBody(world, bx, by, 100, 0) 
   objects.bombs[name].shape = love.physics.newCircleShape(objects.bombs[name].body, 0, 0, 32)
   objects.bombs[name].shape:setData(name)
   objects.bombs[name].shape:setCategory(5) 
   objects.bombs[name].shape:setMask(5, 6)
   objects.bombs[name].brickHit = false
   objects.bombs[name].isDead = false
   objects.bombs[name].markedForDeath = false
   objects.bombs[name].impactX = 0
   objects.bombs[name].impactY = 0
   bombNum = bombNum + 1;
end

function createBullet(name, bx, by)
   objects.bullets[name] = {}
   objects.bullets[name].body = love.physics.newBody(world, bx, by, 20, 0) 
   objects.bullets[name].shape = love.physics.newCircleShape(objects.bullets[name].body, 0, 0, 8)
   objects.bullets[name].shape:setData(name)
   objects.bullets[name].shape:setCategory(7) 
   objects.bullets[name].shape:setMask(2,4,5,6,7,8,9)
   objects.bullets[name].brickHit = false
   objects.bullets[name].isDead = false
   objects.bullets[name].markedForDeath = false
   objects.bullets[name].body:setLinearVelocity(0,-480)
   bulletNum = bulletNum + 1;
end

function createExplosion(name, ex, ey, ix, iy)
   xVal = ex
   yVal = ey
   exNum = math.random(4,6)
   for i = 1, exNum do
      if i > 4 then
         xVal = ex
         yVal = ey + 4
      end
      objects.explosions[name..explosionCount] = {}
      objects.explosions[name..explosionCount].body = love.physics.newBody(world, xVal+ i+4, yVal, math.random(200, 300), i)
      objects.explosions[name..explosionCount].shape = love.physics.newRectangleShape(objects.explosions[name..explosionCount].body, 0, 0, 6, 6, 0) 
      objects.explosions[name..explosionCount].markedForDeath = false;
      objects.explosions[name..explosionCount].shape:setData(name..explosionCount);
      objects.explosions[name..explosionCount].body:applyImpulse( math.random(40), math.random(40), 0, 0 );
      objects.explosions[name..explosionCount].body:setBullet(true)
      objects.explosions[name..explosionCount].avatar = pieces[math.random(5)]
      objects.explosions[name..explosionCount].shape:setCategory(8)
      objects.explosions[name..explosionCount].shape:setMask(2,3,4,5,6)
      explosionCount = explosionCount + 1;
     
      worldUpdate = true
   end;
end

function createBonus(bx, by)
   if(bonusDropping == true)then
    --  print ("Pop")
   bonusNum = bonusNum + 1
   xVal = bx
   yVal = by
   rnd = math.random(100)
   if(rnd > 90) then
      name = "BonusM"..bonusNum  
      --rnd = nil
   elseif (rnd <= 20) then
      name = "BonusB"..bonusNum
      -- rnd = nil
   elseif (rnd > 20 and rnd <= 40) then
      name = "BonusS"..bonusNum
      -- rnd = nil
   elseif (rnd > 40 and rnd <= 60) then
      name = "BonusP"..bonusNum
      -- rnd = nil
   elseif (rnd > 60 and rnd <= 75) then
      name = "BonusL"..bonusNum
   elseif (rnd > 75 and rnd <= 95) then
      name = "BonusC"..bonusNum
      -- print(name)
      -- rnd = nil
   end
   objects.bonuses[name] = {}
   objects.bonuses[name].body = love.physics.newBody(world, xVal, yVal, 300, 0)
   objects.bonuses[name].shape = love.physics.newRectangleShape(objects.bonuses[name].body, 0,0,32,16, 0)
   objects.bonuses[name].body:setBullet(true)
   objects.bonuses[name].shape:setMask(3,4,5,6)
   objects.bonuses[name].shape:setCategory(4) 
   objects.bonuses[name].intScore = 500
   objects.bonuses[name].markedForDeath = false
   objects.bonuses[name].shape:setData(name)
  -- print(name)
   bonusDropping = false
 end
end

function activateBonus(strBonus)
   if string.find(strBonus, "BonusP") ~= nil then
      score = score + objects.bonuses[strBonus].intScore
      playSound(sfx_bonus)
   elseif string.find(strBonus, "BonusB") ~= nil then
      createBall("Ball"..ballNum, objects.bonuses[strBonus].body:getX(), objects.paddle.body:getY() - 32, true)
   elseif string.find(strBonus, "BonusS") ~= nil then
      ammo = 20
   elseif string.find(strBonus, "BonusM") ~= nil then
        createBallSplosion()   
   elseif string.find(strBonus, "BonusL") ~= nil then
        intLives = intLives + 1
   elseif string.find(strBonus, "BonusC") ~= nil then
      for i in pairs(objects.balls) do
	 if(objects.balls[i].markedForDeath == false) then
	    objects.balls[i].isBomb = true
	 end
     end
   end
  --killBonus(strBonus)
  killObject(objects.bonuses[strBonus])
  objects.bonuses[strBonus].body:setY(600)	
end

function love.update(dt)
   if(gameMode == "GAME_PLAY") then
      gameUpdate(dt)
   end
end

function gameUpdate(dt)
     world:update(dt)
     if love.keyboard.isDown(" ") then
	if ballAlive == false then 
	   ballReset = false
	   ballAlive = true;
	   love.mouse.setGrab(true)
	   love.mouse.setVisible(false)
	   playSound(sfx_serve)
	end
     end
     if love.keyboard.isDown("q") then
        love.mouse.setGrab(false)
	love.mouse.setVisible(true)
     end
     if love.keyboard.isDown("escape") then
         love.event.push('q')
      end
     if love.keyboard.isDown("s") then
        if soundEnabled == true then
	    soundEnabled = false
	else soundEnabled = true
	end
     end
   
     if love.mouse.isDown("l") then 
        if  ammo > 0 and ballAlive == true and bitMouseDown == false then
	   createBullet("Bullet"..bulletNum,paddleX+32, paddleY )
	   bitMouseDown = true
	   ammo = ammo - 1
	end
     elseif love.mouse.isDown("l") == false then
	bitMouseDown = false
     end
     
     local intBalls = 0
     for i in pairs(objects.balls) do
	 bx, by = objects.balls[i].body:getPosition()
         if(objects.balls[i].markedForDeath == true) then
	
	  objects.balls[i].shape:destroy()
	  objects.balls[i].body:destroy()
	  objects.balls[i] = nil
        
	 elseif(objects.balls[i].markedForDeath == false) then
	    intBalls = intBalls+1
	    if objects.balls[i].ballHit==true then	    
	       impactX = bx - objects.paddle.body:getX();
    	       objects.balls[i].body:applyImpulse(impactX * 10, -640, 0, 0) 
               objects.balls[i].ballHit = false;
	       playSound(sfx_reflect)
	    elseif  objects.balls[i].wallHit == true then

	       objects.balls[i].body:applyImpulse(-objects.balls[i].impactX, 0, 0, 0) 
	       objects.balls[i].wallHit = false;
	   
	    elseif  objects.balls[i].ceilingHit == true then

	       objects.balls[i].body:applyImpulse(0 ,-objects.balls[i].impactY, 0, 0) 
	       objects.balls[i].ceilingHit = false;

	    elseif objects.balls[i].brickHit == true then
	       objects.balls[i].body:applyImpulse(objects.balls[i].impactX * 10 ,-objects.balls[i].impactY, 0, 0) 
	       objects.balls[i].brickHit = false;
	       playSound(arrSoundBooms[intBoomIdx])
	       intBoomIdx = intBoomIdx+1
	       if intBoomIdx > 2 then
	          intBoomIdx = 0
	       end
	    
	   end
      	  
           ax, ay = objects.balls[i].body:getLinearVelocity() 
           if(ay == 0 and ballAlive == true) then
	      objects.balls[i].intIdleFrames = objects.balls[i].intIdleFrames + 1
	      if(objects.balls[i].intIdleFrames >= 1) then
	         print("Pop UP!")
		 objects.balls[i].body:applyImpulse(0, -100, 0, 0)
	      end
	   elseif (ay ~= 0) then objects.balls[i].intIdleFrames = 0 end
	   
           local setSpeed = false
	   if(ay > 640) then
	     ay = 640
	      setSpeed = true
	   elseif (ay < -640) then
	     ay = -640
	      setSpeed = true
	   end
	   if(ax > 480) then
	     ax = 480
	      setSpeed = true
	   elseif (ax < -480) then
	     ax = -480
	      setSpeed = true
	   end
	   if setSpeed == true then
	      objects.balls[i].body:setLinearVelocity(ax, ay)
	   end
	   
	  
	end
 
     end
     if ballReset == true then
	ballReset = false
     end
     if ballAlive == false then
	for i in pairs(objects.balls) do
       	    objects.balls[i].body:setX(paddleX + 32) 
	    objects.balls[i].body:setY(paddleY - 10)
	end
     end
     paddleX = love.mouse.getX() - paddle:getWidth()/2
     if paddleX < 0 then 
	paddleX = 0
     elseif paddleX > screenWidth - paddle:getWidth() then 
  	paddleX = screenWidth - paddle:getWidth()
     end
     objects.paddle.body:setX(paddleX + paddle:getWidth()/2)
     objects.paddle.body:setY(paddleY + paddle:getHeight()/2)
     -- objects.ball.body:applyTorque(rot)
     -- rot = rot + 1;
     -- if rot > 360 then
     --    rot = 0
  --end 
      
 --
   -- for i in pairs(objects.balls) do
  --  end
 -- print(intBalls)
  if(intBalls == 0) then
      ballReset = true;
      ballAlive = false;
      intLives = intLives - 1;
      print(intLives)
      if intLives <= 0 then
	 intLives = 0
	 print("GAME OVER")
         strMessage = "GAME OVER";
      elseif intLives > 0 then
	 ammo = 0
	 createBall("Ball"..ballNum, 320, 465, false)
	 for i in pairs(objects.bonuses) do
	    if objects.bonuses[i].markedForDeath ~= true then
	       objects.bonuses[i].body:setY(600)
	    end 
	 end
	 for i in pairs(objects.bullets) do
	    if objects.bullets[i].markedForDeath ~= true then
	       objects.bullets[i].body:setY(-100)
	    end
	 end
      end
   end
   for i in pairs(objects.explosions) do
     --if i > 0 then
    -- print(i)
    -- if(objects.explosions[i].markedForDeath == true) then
     if(objects.explosions[i].body:getY() > 525) then
	objects.explosions[i].shape:destroy()
	objects.explosions[i].body:destroy()
	objects.explosions[i].image = nil
	objects.explosions[i] = nil	
     end
  end
   for i in pairs(objects.bricks) do
       if(objects.bricks[i].markedForDeath == true) then
	
	  objects.bricks[i].shape:destroy()
	  objects.bricks[i].body:destroy()
	  objects.bricks[i].image = nil
	  objects.bricks[i] = nil
	--table.remove(objects.explosions[i])
      end
   end
 
   for i in pairs(objects.bonuses) do

      -- if(objects.bonuses[i].markedForDeath == true) then
      if(objects.bonuses[i].body:getY() > 525) then
	  objects.bonuses[i].shape:destroy()
	  objects.bonuses[i].body:destroy()
	 -- objects.bonuses[i].image = nil
	  objects.bonuses[i] = nil
	--table.remove(objects.explosions[i])
      end
   end
    for i in pairs(objects.bullets) do

      if(objects.bullets[i].markedForDeath == true and objects.bullets[i].body:getX() < 0) then
	  objects.bullets[i].shape:destroy()
	  objects.bullets[i].body:destroy()
	 -- objects.bonuses[i].image = nil
	  objects.bullets[i] = nil
	--table.remove(objects.explosions[i])
       elseif (objects.bullets[i].body:getY() < 0) then
	 -- killBullet(i);
	  killObject(objects.bullets[i])
       end
   end
   
   for i in pairs(objects.bombs) do

      if(objects.bombs[i].markedForDeath == true and objects.bombs[i].body:getX() < 0) then
	  objects.bombs[i].shape:destroy()
	  objects.bombs[i].body:destroy()
	 -- objects.bonuses[i].image = nil
	  objects.bombs[i] = nil
	--table.remove(objects.explosions[i])
      end
   end
end

function drawMap()
   arrMap = getMap(currentLevel)
   tx = 0 
   ty = 0
   brickNum = 0
   for y=1, 16 do
      for x=1, 20 do                                     
	 if arrMap[y][x] ~= 0 then                   
	    createBrick("Brick"..brickNum, tx, ty, arrMap[y][x]);
	    brickNum = brickNum+1;   
         end
	  tx = tx+34
      end
      tx = 0
      ty = ty+18
     
   end
  
end

	 
function love.draw()
   drawGame()
end

function drawGame()
  love.graphics.setColor(255, 255, 255) 
  love.graphics.draw(bg, 0, 0)
  love.graphics.draw(paddle, paddleX, paddleY)
  love.graphics.setColor(193, 47, 14)  
 
  love.graphics.setColor(255, 255, 255) 
--  love.graphics.draw(ball, objects.ball.body:getX() - ball:getWidth()/2, objects.ball.body:getY() - ball:getHeight()/2)
 
  local count = 0
  for i in pairs(objects.balls) do 
     local by = objects.balls[i].body:getY()
     if (by < 500) then
	if(objects.balls[i].isBomb == true) then
	   love.graphics.draw(ballBomb, objects.balls[i].body:getX() - ballBomb:getWidth()/2, by - ballBomb:getHeight()/2)	
	elseif(objects.balls[i].isBomb == false) then
	   love.graphics.draw(ball, objects.balls[i].body:getX() - ball:getWidth()/2, by - ball:getHeight()/2)
	end
     elseif (by > 500) then
	--killBall(i)
	killObject(objects.balls[i])
     end
  end
   for i in pairs(objects.bricks) do
      local brY = objects.bricks[i].body:getY()
      if(brY > 0) then
         love.graphics.draw(objects.bricks[i].avatar, objects.bricks[i].body:getX() - brick:getWidth()/2 , brY - brick:getHeight()/2)
         count = count + 1
      end
   end
  for i in pairs(objects.explosions) do
     love.graphics.draw(objects.explosions[i].avatar, objects.explosions[i].body:getX() - objects.explosions[i].avatar:getWidth()/2 , objects.explosions[i].body:getY() - objects.explosions[i].avatar:getHeight()/2)
  end
 
   for i in pairs(objects.bonuses) do
      bnY =  objects.bonuses[i].body:getY()
      if string.find(i, "BonusB")~= nil and bnY < 465 then
	    love.graphics.draw(bonusBall, objects.bonuses[i].body:getX() - bonusBall:getWidth()/2 , bnY - bonusBall:getHeight()/2)
      elseif string.find(i, "BonusP") ~= nil and bnY < 465 then
	     love.graphics.draw(bonusImage, objects.bonuses[i].body:getX() - bonusImage:getWidth()/2 , bnY - bonusImage:getHeight()/2)
      elseif string.find(i, "BonusS") ~= nil and bnY < 465 then
	     love.graphics.draw(bonusShot, objects.bonuses[i].body:getX() - bonusShot:getWidth()/2 , bnY - bonusShot:getHeight()/2)
      elseif string.find(i, "BonusM") ~= nil and bnY < 465 then
	     love.graphics.draw(bonusMultiBall, objects.bonuses[i].body:getX() - bonusMultiBall:getWidth()/2 , bnY - bonusMultiBall:getHeight()/2)
      
       elseif string.find(i, "BonusC") ~= nil and bnY < 465 then
	     love.graphics.draw(bonusBomb, objects.bonuses[i].body:getX() - bonusBomb:getWidth()/2 , bnY - bonusBomb:getHeight()/2) 
       
       elseif string.find(i, "BonusL") ~= nil and bnY < 465 then
	     love.graphics.draw(bonusPaddle, objects.bonuses[i].body:getX() - bonusPaddle:getWidth()/2 , bnY - bonusPaddle:getHeight()/2) 
    
      end
   end

   for i in pairs(objects.bullets) do
      blY =  objects.bullets[i].body:getY()
      love.graphics.draw(bullet, objects.bullets[i].body:getX() - bullet:getWidth()/2 , blY - bullet:getHeight()/2)
   end

  text = " "..count
  if count == 0 then
     text = "You Won!"
     currentLevel = currentLevel+1;
     if currentLevel > maxLevel then
	text = "Congratulations!"
     else
	 for i in pairs(objects.explosions) do
	    if objects.explosions[i].markedForDeath ~= true then
	      -- killExplosion(i)
	       killObject(objects.explosions[i])
	    end
	 end
	  for i in pairs(objects.bonuses) do
	    if objects.bonuses[i].markedForDeath ~= true then
	       --killBonus(i)
	       killObject(objects.bonuses[i])
	       objects.bonuses[i].body:setY(600)	
	    end
	 end
	 for i in pairs(objects.balls) do
	    if objects.balls[i].markedForDeath ~= true then
	      -- killBall(i)
	       objects.balls[i].ballReset = true;
	       objects.balls[i].ballAlive = false;
	       killObject(objects.balls[i])
	    end
	 end
         for i in pairs(objects.bullets) do
	    if objects.bullets[i].markedForDeath ~= true then
	       --killBullet(i)
	       killObject(objects.bullets[i])
	    end
	 end
	drawMap()
     end
     ballReset = true
     ballAlive = false
  end
  if(ammo > 0) then
     love.graphics.print("Click M1 to Shoot: Ammo: "..ammo, 225,4)
  end
  if (intLives == 0) then
     love.graphics.print("GAME OVER", 280, 4)
  end
  love.graphics.print("Score: "..score,8,4)
end

function add(a, b, coll)
   if ballAlive == true then
    if (a == "Paddle" and string.find(b, "Ball")) then --or (string.find(a, "Ball") and b == "Paddle") then
       if(objects.balls[b].ballHit ~= true) then
	   objects.balls[b].impactX, objects.balls[b].impactY = coll:getVelocity()
	   objects.balls[b].ballHit = true;
	end
    elseif (a == "Wall" and string.find(b, "Ball")) then 
        objects.balls[b].impactX, objects.balls[b].impactY = coll:getVelocity();
        objects.balls[b].wallHit = true;
    elseif (a == "Ceiling" and string.find(b, "Ball") ~= nil) then 
       objects.balls[b].impactX, objects.balls[b].impactY = coll:getVelocity();
       objects.balls[b].ceilingHit = true;
    elseif ballAlive == true and string.find(a, "Brick") ~= nil and string.find(b, "Ball") ~= nil then
       healBrickHP(a, -1)
       objects.balls[b].impactX, objects.balls[b].impactY = coll:getVelocity();
       objects.balls[b].impactX = objects.balls[b].body:getX() - objects.bricks[a].body:getX();
       local brickX, brickY = objects.bricks[a].body:getPosition()
       if (objects.bricks[a].intHP <= 0) then	
	  createExplosion("Explosion", objects.bricks[a].body:getX(), objects.bricks[a].body:getY(), impactX, impactY)
	  if (objects.bricks[a].body:getX() > 0) then
	     if(math.random(100) > 50 and bonusDropping == false) then
		bonusDropping = true
		createBonus(objects.bricks[a].body:getX(), objects.bricks[a].body:getY())
	     end 
	     objects.bricks[a].body:setX(objects.bricks[a].body:getX() * -1)
	     objects.bricks[a].body:setY(objects.bricks[a].body:getY() * -1)
	  end
	 if(objects.bricks[a].markedForDeath == false) then
	    objects.bricks[a].markedForDeath = true;
	 end
         
      end
      
       score = score + 100
       objects.balls[b].brickHit = true;
       if(objects.balls[b].isBomb == true) then
	  objects.balls[b].isBomb = false;
          createBomb("Bomb"..bombNum, brickX, brickY)
	  
       end
     elseif (string.find(b,"Bonus") ~= nil and a == "Paddle")  then
       if(objects.bonuses[b].markedForDeath == false) then
          activateBonus(b)
       end
    elseif (string.find(a,"Brick") and string.find(b, "Bullet") ~= nil) then 
       createExplosion("Explosion", objects.bricks[a].body:getX(), objects.bricks[a].body:getY(), impactX, impactY)
       if objects.bullets[b].markedForDeath == false then
	     --killBullet(b)
	     killObject(objects.bullets[b])
	     score = score + 100 
       end
        if (objects.bricks[a].body:getX() > 0) then
	     objects.bricks[a].body:setX(objects.bricks[a].body:getX() * -1)
	     objects.bricks[a].body:setY(objects.bricks[a].body:getY() * -1)
	  end
	 if(objects.bricks[a].markedForDeath == false) then
	    objects.bricks[a].markedForDeath = true;
	    
	 end 
      --end

    elseif (string.find(a,"Brick") and string.find(b, "Bomb") ~= nil) then 
       createExplosion("Explosion", objects.bricks[a].body:getX(), objects.bricks[a].body:getY(), impactX, impactY)
       if objects.bombs[b].markedForDeath == false then
	    -- killBomb(b)
	     killObject(objects.bombs[b])
	     score = score + 100 
       end
        if (objects.bricks[a].body:getX() > 0) then
	     objects.bricks[a].body:setX(objects.bricks[a].body:getX() * -1)
	     objects.bricks[a].body:setY(objects.bricks[a].body:getY() * -1)
	  end
	 if(objects.bricks[a].markedForDeath == false) then
	    objects.bricks[a].markedForDeath = true;
	    
	 end 
       end
  end
end

function playSound(snd)
   if soundEnabled == true then
      love.audio.play(snd)
   end
end
 
--function killBall(a)
--    objects.balls[a].isDead = true
--    objects.balls[a].ballReset = true;
--    objects.balls[a].ballAlive = false;
--    objects.balls[a].body:setMass(0,0,0,0)
--    if objects.balls[a].body:getX() > 0 then
--	  objects.balls[a].body:setX(objects.balls[a].body:getX() * -1) 
--    end
--    objects.balls[a].markedForDeath = true;
   
--end 

--function killBullet(a)
--   objects.bullets[a].markedForDeath = true
--    objects.bullets[a].body:setMass(0,0,0,0)
--    if objects.bullets[a].body:getX() > 0 then
--	  objects.bullets[a].body:setX(objects.bullets[a].body:getX() * -1) 
--    end
--    objects.bullets[a].markedForDeath = true;
   
--end 

--function killBomb(a)
--    objects.bombs[a].markedForDeath = true
--    objects.bombs[a].body:setMass(0,0,0,0)
--    if objects.bombs[a].body:getX() > 0 then
--	  objects.bombs[a].body:setX(objects.bombs[a].body:getX() * -1) 
--    end
--    objects.bombs[a].markedForDeath = true;
   
--end 

--function killExplosion(a)
--    objects.explosions[a].body:setMass(0,0,0,0)
--    objects.explosions[a].body:putToSleep()
--    if (objects.explosions[a].body:getX() > 0) then
--        objects.explosions[a].body:setX(objects.explosions[a].body:getX() * -1)
--    end
--    objects.explosions[a].markedForDeath = true	
--end 

--function killBonus(a)
--    objects.bonuses[a].body:setMass(0,0,0,0)
--    objects.bonuses[a].body:putToSleep()
--    if (objects.bonuses[a].body:getX() > 0) then
--        objects.bonuses[a].body:setX(objects.bonuses[a].body:getX() * -1)
--    end
--    objects.bonuses[a].markedForDeath = true
--    objects.bonuses[a].body:setY(600)	
-- end

function killObject(obj)
    obj.isDead = true
    obj.body:setMass(0,0,0,0)
    if obj.body:getX() > 0 then
	  obj.body:setX(obj.body:getX() * -1) 
    end
    obj.markedForDeath = true;
    

end